#4 Crash with 'unknown' midi events

closed-fixed
nobody
None
5
2010-10-25
2008-08-15
Frank
No

Hi, this is just one annoying thing i wanted to report besides encouragements for this very nice synthesizer.
I work with a freshly compiled AMS (thanks for the build updates here!) svn version.
When working with qtractor and AMS, the following happens. When a sequence is started even with an empty track of which the midi output is connected to AMS via alsa midi (qjackctl), AMS segfaults. I analyzed as good as I could using qmidiroute what comes out from qtracktor upon start with empty tracks, and the eventlog reports the following.
19:43:03.188 Unknown event type
19:43:03.193 Unknown event type
19:43:03.197 Ch 0, Ctrl 7, Val 127
19:43:03.203 Ch 0, Ctrl 10, Val 64

Upon Stop qtractor sends the following

19:43:15.975 Ch 0, Ctrl 120, Val 0
19:43:15.980 Ch 0, Ctrl 123, Val 0

AMS crashes immediately with segfault upon start, but keeps running OK on stop, meaning that the controllers are probably innocent.... So there seem to be unknown (fatal ;-) ) midi event types that happen to be not handeled.

If you think the first is true I'll report at qtractor, thank you responding in this case.
And thanks for making this software!

Discussion

  • Logged In: NO

    Hi,
    I can confirm this bug, which is not present in the old 1.8.8 version.

    Did you subsribe one of the project mailinglists?

    Regards
    Guido

     
  • Frank
    Frank
    2008-08-25

    Logged In: YES
    user_id=2065922
    Originator: YES

    Hi,
    no I didn't subscribe yet, but I will.
    I somewhat fixed that problem meanwhile, absolutely sure that this is not the right way to do it ;-) . The function SynthData::readMIDI (synthdata.cpp) doesn't handle SYSEX events which are cast by qtractor on start. I inserted a mutex unlock and return; upon ev->type == SND_SEQ_EVENT_SYSEX in that function and it "fixed" that crash so that I can work OK with it now, but you will probably have the correct fix for this...
    Thanks for your reply
    Regards
    Frank

     
  • Guido Scholz
    Guido Scholz
    2008-08-27

    Logged In: YES
    user_id=19263
    Originator: NO

    Hi Frank,
    this bug is fixed now in cvs. Please give it a try.
    Guido

     
  • Frank
    Frank
    2008-08-28

    Logged In: YES
    user_id=2065922
    Originator: YES

    Thank you Guido for that fix, works great now
    Cheers
    Frank

     
  • Karsten
    Karsten
    2009-02-27

    • status: open --> closed
     
  • Guido Scholz
    Guido Scholz
    2010-10-25

    • status: closed --> closed-fixed